from analysis.very_busy_expressions import VeryBusyExpressions
from lang.to_cfg import stringToCFG
from analysis.fixed_point import fixed_point
from lang.ast import BinaryExpression, Variable, BinOp
from lang.utils import getValueByLabel

def test_very_busy_expressions_1():
    s = r"""
    l1: if (a>b) {
          x = b-a;
          y = a-b;
        } else {
          y = b-a;
          x = a-b;
        }
    """
    cfg = stringToCFG(s)
    In, Out = fixed_point(cfg, VeryBusyExpressions(cfg))
    res = getValueByLabel("l1", In)
    assert(BinaryExpression(Variable("a"), BinOp.Minus, Variable("b")) in res)
    assert(BinaryExpression(Variable("b"), BinOp.Minus, Variable("a")) in res)
